(*--------------------------------------------------------------------------+
 |                                                                          |
 |                   Bote  outils pour les arbres binaires                |
 |                                                                          |
 |  M. Quercia, le 06/08/96                                                 |
 +--------------------------------------------------------------------------+*)


type 'a b_arbre = B_vide | B_noeud of 'a * ('a b_arbre) * ('a b_arbre);;

value b_map : ('a -> 'b) -> ('a b_arbre -> 'b b_arbre);;
(* "g_map f a" applique "f"  chaque noeud de "a" et renvoie
   l'arbre des rsultats *)

value b_arbre : string -> string b_arbre;;
(* "g_arbre chaine" interprte "chaine" comme la description parenthse
   d'un arbre et renvoie cet arbre *)

value print_b_arbre : string b_arbre -> unit;;
(* "print_g_arbre a" imprime "a" sous forme graphique.
   Les fonctions d'impression sont celles de la bibliothque "format" *)

value int_b_arbre : string -> int b_arbre;;
value print_int_b_arbre : int b_arbre -> unit;;
(* lecture et impression d'arbres  tiquettes entires *)
